require 'back_office/engine'
require 'back_office/auth'
require 'back_office/password'
require 'back_office/policy'
require 'back_office/reset'
require 'back_office/rest'

module BackOffice
  def self.verifier
    Rails.application.message_verifier('back_office')
  end

  def self.encrypt(value, expiration = 8.days)
    verifier.generate([value, expiration.from_now])
  end

  def self.decrypt(token)
    value, expiration = verifier.verify(token)
    value if expiration > Time.current
  rescue ActiveSupport::MessageVerifier::InvalidSignature
    nil
  end
end
