module BackOffice
  class Password
    include ActiveModel::Model

    attr_accessor :email, :plaintext, :plaintext_confirmation

    validates :plaintext, on: :update, presence: true, confirmation: true

    def update(attrs)
      self.plaintext              = attrs[:plaintext]
      self.plaintext_confirmation = attrs[:plaintext_confirmation]

      if valid?(:update)
        user.update(password: plaintext)
        true
      end
    end

    def user
      User.find_by(email: email) if email
    end
  end
end
