module BackOffice
  module Policy
    def authorized?(controller, action, resource = nil)
      if rule = rules.dig(controller.to_sym, action.to_sym)
        rule == true || resource && rule.call(resource)
      else
        false
      end
    end

    private

    def authorize(controller, *actions, &block)
      actions.flatten.each { |action| rules[controller][action] = (block || true) }
    end

    def rules
      @rules ||= Hash.new { |hash, key| hash[key] = {} }
    end
  end
end
