module BackOffice
  class Reset < Password
    attr_reader :token
    validates   :email,          on: :create, presence: true
    validate    :user_existence, on: :create

    def self.find(token)
      if email = BackOffice.decrypt(token)
        new(email: email, token: token)
      end
    end

    def to_param
      token
    end

    def save
      if token.nil? && valid?(:create)
        @token = BackOffice.encrypt(email)
        true
      end
    end

    private

    def user_existence
      errors.add(:email, :not_registered) unless user
    end
  end
end
